Igor Murashkin | 96bd019 | 2012-11-19 16:49:37 -0800 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | |
| 3 | # |
| 4 | # Copyright (C) 2012 The Android Open Source Project |
| 5 | # |
| 6 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 7 | # you may not use this file except in compliance with the License. |
| 8 | # You may obtain a copy of the License at |
| 9 | # |
| 10 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 11 | # |
| 12 | # Unless required by applicable law or agreed to in writing, software |
| 13 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 14 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 15 | # See the License for the specific language governing permissions and |
| 16 | # limitations under the License. |
| 17 | # |
| 18 | |
| 19 | # |
| 20 | # Sanity check the XML parser by making sure it's generating the same data |
| 21 | # as the original parsed data. |
| 22 | # |
| 23 | |
Eino-Ville Talvala | 0888556 | 2013-03-18 09:43:57 -0700 | [diff] [blame] | 24 | thisdir=$(cd "$(dirname "$0")"; pwd) |
Igor Murashkin | 96bd019 | 2012-11-19 16:49:37 -0800 | [diff] [blame] | 25 | |
Igor Murashkin | 0334aa0 | 2012-12-04 14:59:53 -0800 | [diff] [blame] | 26 | $thisdir/metadata-check-dependencies || exit 1 |
| 27 | |
Eino-Ville Talvala | 0888556 | 2013-03-18 09:43:57 -0700 | [diff] [blame] | 28 | tmp_out=$(mktemp -t tmp.XXXXXXXXXX) |
| 29 | tmp_tidy1=$(mktemp -t tmp.XXXXXXXXXX) |
| 30 | tmp_tidy2=$(mktemp -t tmp.XXXXXXXXXX) |
Igor Murashkin | 96bd019 | 2012-11-19 16:49:37 -0800 | [diff] [blame] | 31 | |
Igor Murashkin | 0b08045 | 2013-12-27 15:30:25 -0800 | [diff] [blame] | 32 | function check_test |
| 33 | { |
| 34 | local file="$1" |
| 35 | local results |
| 36 | results="$(python "$file" 2>&1)" |
| 37 | local retval=$? |
| 38 | if [[ $retval -ne 0 ]] |
| 39 | then |
| 40 | echo "$results" >& 2 |
| 41 | echo "FAILED: Unit tests $file" |
| 42 | else |
| 43 | echo "SUCCESS: Unit tests $file" |
| 44 | fi |
| 45 | return $retval |
| 46 | } |
| 47 | |
| 48 | check_test "$thisdir/metadata_model_test.py" || exit 1 |
| 49 | check_test "$thisdir/metadata_helpers_test.py" || exit 1 |
Igor Murashkin | 4809868 | 2012-12-05 14:51:57 -0800 | [diff] [blame] | 50 | python $thisdir/metadata_parser_xml.py $thisdir/metadata_properties.xml $thisdir/metadata_template.mako $tmp_out || exit 1 |
Igor Murashkin | 96bd019 | 2012-11-19 16:49:37 -0800 | [diff] [blame] | 51 | tidy -indent -xml -quiet $thisdir/metadata_properties.xml > $tmp_tidy1 |
| 52 | tidy -indent -xml -quiet $tmp_out > $tmp_tidy2 |
| 53 | |
| 54 | diff $tmp_tidy1 $tmp_tidy2 |
| 55 | exit_code=$? |
| 56 | rm $tmp_out $tmp_tidy1 $tmp_tidy2 |
| 57 | |
| 58 | if [[ $exit_code -ne 0 ]] |
| 59 | then |
| 60 | echo "ERROR: Files differ, please check parser logic" 1>&2 |
| 61 | else |
| 62 | echo "SUCCESS: Files are the same!" 1>&2 |
| 63 | fi |
| 64 | |
| 65 | exit $exit_code |